import java.util.HashSet;
import java.util.Iterator;
import java.util.ListIterator;

/*
 * Aufgabe: Davis Putnam mithilfe der Datenstrukturen Variable, Klausel und Klauselmenge implementieren.
 * Dabei sollte die Datenstruktur an sich nicht verandert werden.
 *  
 * Format der Ausgabe für die GUI soll ein Anweisungsbaum sein, der in der Klasse "Anweisungsbaum" definiert ist.
 * Anweisungsbaum:  ( String reg, String name, int wert,Klauselmenge kls, Klauselmenge kls2, Anweisungsbaum links, Anweisungsbaum rechts)
 * 
 */



/*
 * Einige Beispielaufgaben zum Copy/Pasten:
 * 
 * 1. {!p},{!t,q,p},{!s,!q},{s,!q,t},{r,!p},{!r},{!s,!q,s}
 * 
 * 2. {a,b,c},{a,b,!c},{!a,b,c},{!a,!b,c}
 * 
 * 3. {!a,!b,!d},{!e},{!c,a},{c},{b},{!g,d},{g}
 * 
 * 4. {!c,a},{c},{!a,!b,!d},{b},{!g,d},{g},{!e}
 * 
 * 5. {a,A},{a,B},{a,C},{a,D},{b,A},{b,B},{b,C},{b,D},{c,A},{c,B},{c,C},{c,D},{d,A},{d,B},{d,C},{d,D}
 * 
 * 6. {a,b,c,d,e},{a,b,!c,d,e},{a,!b,c,d,e},{a,!b,!c,d,e},{!a,b,c,d,e},{!a,b,!c,d,e},{!a,!b,c,d,e},{!a,!b,!c,d,e},{a,b,c,!d,e},{a,b,!c,!d,e},{a,!b,c,!d,e},{a,!b,!c,!d,e},{!a,b,c,!d,e},{!a,b,!c,!d,e},{!a,!b,c,!d,e},{!a,!b,!c,!d,e},{a,b,c,d,!e},{a,b,!c,d,!e},{a,!b,c,d,!e},{a,!b,!c,d,!e},{!a,b,c,d,!e},{!a,b,!c,d,!e},{!a,!b,c,d,!r,!e},{!a,!b,!c,d,!e},{a,r,b,c,!d,!e},{a,b,!c,!d,!e},{a,!b,c,!d,!e},{a,!b,!c,f,!d,!e},{!a,b,c,!d,!e},{!a,b,!c,!f,!d,!e},{!a,!b,c,!d,!e},{!a,!b,!c,!d,!e},{f,a,b,!r}
 * 
 * 7. {q,r},{r,t,q,!t},{!p},{s,!t,!q,!r},{q,!r},{!q,r},{!p,!s,p}
 */

public class DavisPutnam {
	
	public static Anweisungsbaum algorithmus(Klauselmenge klauseln){
		
		/*
		 * 
		 * BEISPIELLOESUNG
		 * 
		 * Anmerkung: Es werden alle Zweige gebaut und nicht nur nach Erfuellbarkeit geprueft.
		 * 
		 */
		
		System.out.println("-.-.-.-.-.-.----.-.-.-.-.-.-.-.-.-");
		System.out.println("Ubergebene Klauselmenge: "+ klauseln.toString());	
		
		Anweisungsbaum a = new Anweisungsbaum();		
		System.out.println("Bottom? : " + klauseln.getIsBottom());
		System.out.println("Top? : " + klauseln.getIsTop());
		System.out.println(klauseln.getClass());
		
		//Rekursionsanker sind Top- und Bottommengen
		if(klauseln.getIsBottom()){
			System.out.println("Bottomklauselmenge! Ende der Rekursion.");
			return new Anweisungsbaum("BOTTOM", "BOTTOM", 0,klauseln, null, null, null);
		}
		
		if(klauseln.getIsTop()){
			System.out.println("Topklauselmenge! Ende der Rekursion.");
			return new Anweisungsbaum("TOP", "TOP", 1,klauseln, null, null, null);
		}
		
		
		
		if (pure(klauseln,a)){
			System.out.println("Pure angewendet!");
			klauseln = klauseln.evalForm();
			
			a.regel = "PURE";
			a.aktKlauseln = klauseln.evalForm();
			System.out.println("Nach pure Klauseln im baum: " + a.aktKlauseln.toString());
			a.linkeRegel = algorithmus(klauseln);		
			return a;
		}
		
		
		if (unit(klauseln,a)){
			System.out.println("Unit angewendet!");
			klauseln = klauseln.evalForm();
			a.regel = "UNIT";
			a.aktKlauseln = klauseln.evalForm();
			System.out.println("Nach unit Klauseln im baum: " + a.aktKlauseln.toString());			
			a.linkeRegel = algorithmus(klauseln);	
			return a;
		} 
			
		if (subsumption(klauseln,a)){
			System.out.println("Subsumption!");
			a.regel = "SUBSUMPTION";
			a.aktKlauseln =new Klauselmenge(klauseln.getKlauseln());;
			System.out.println("Nach sub Klauseln im baum: " + a.aktKlauseln.toString());
			a.linkeRegel = algorithmus(klauseln);		
			return a;
		}
		
		System.out.println("Split!");
			
			
		Variable zuSplitten = split(klauseln);
		System.out.println("Variable zu splitten: "+zuSplitten.getBezeichner());
		
		
		
		Klauselmenge klauselnLinks = new Klauselmenge(klauseln.getKlauseln()); //deep copy
		Klauselmenge klauselnRechts = new Klauselmenge(klauseln.getKlauseln());	//deep copy
		
		a.regel = "SPLIT";
		
		a.bezeichner = zuSplitten.getBezeichner();		
		
		klauselnLinks.belegeVariable(zuSplitten.getBezeichner(), 0);
		a.aktKlauseln = klauselnLinks.evalForm();
		klauselnLinks = klauselnLinks.evalForm();
		
		klauselnRechts.belegeVariable(zuSplitten.getBezeichner(), 1);
		a.aktKlauseln2 = klauselnRechts.evalForm();
		klauselnRechts = klauselnRechts.evalForm();
		
		System.out.println("Konstruierter Baum mit linker Menge: "+  a.aktKlauseln);
		a.linkeRegel = algorithmus(klauselnLinks);
		
		System.out.println("Konstruierter Baum mit rechter Menge: "+  a.aktKlauseln2);
		a.rechteRegel = algorithmus(klauselnRechts);
		
		
		
		return a;
			
		
			
		}
			
		
		
		
		
		
		
	
	private static boolean pure(Klauselmenge klm, Anweisungsbaum a){
		/*
		 * Fuhrt Pure Regel auf der Klauselmenge einmal durch. Gibt zuruck, ob Regel angewendet wurde.
		 */
		
		/*
		 * Idee: Gebe alle Variablen (getVariablenOhneNegation) einmal durch. FÜr jede Variable pruft man, ob sie nur negiert oder nicht negiert vorkommt (in getVariablenMitNegation).
		 */
		
		HashSet<String> varsO = klm.getVariablenOhneNegation();
		HashSet<String> varsM = klm.getVariablenMitNegation();
		
		
		
		System.out.println("Pure-Regel: ");
		System.out.println("Variablen: " + varsO.toString());
		System.out.println("Variabelvorkommen mit Negation: "+ varsM.toString());
		
		Iterator<String> iter = varsO.iterator();		
		while (iter.hasNext()) {		//Für alle Variablen...
			String betrachtet = iter.next();
			if (varsM.contains(betrachtet) && !varsM.contains("!"+betrachtet)){
				//Fall 1: Menge enthält nur nicht negierte Variable.
				a.setBelegung(1);
				a.setBezeichner(betrachtet);
				klm.belegeVariable(betrachtet, 1);
				
				return true;
				
			}else{
				if (!varsM.contains(betrachtet) && varsM.contains("!"+betrachtet)){
					//Fall 1: Menge enthalt nur negierte Variable.
					a.setBelegung(0);
					a.setBezeichner(betrachtet);
					klm.belegeVariable(betrachtet, 0);
					return true;
				}
			}
		}
		
		return false;
	}
	
	private static boolean unit(Klauselmenge klm,Anweisungsbaum a){
		/*
		 * Fuehrt unit Regel auf der Klauselmenge durch. Gibt zuruck, ob Regel angewendet wurde.
		 */
		
		/*
		 * Idee: Gehe jede Klausel durch und prufe auf größe.
		 */
		
		System.out.println("Unit-Regel: ");
		ListIterator<Klausel> litr = klm.getKlauseln().listIterator();
		
		while (litr.hasNext()) {
			Klausel element = litr.next();
			if (element.getGroeße() == 1){
				String varName = element.getVariablen().get(0).getBezeichner();
				if (element.getVariablen().get(0).getNegiert()){
					a.setBelegung(0);
					a.setBezeichner(varName);
					System.out.println("Unit mit : "+ varName);
					
					klm.belegeVariable(varName, 0);
					return true;
				}else {
					a.setBelegung(1);
					a.setBezeichner(varName);
					System.out.println("Unit mit : "+ varName);
					
					klm.belegeVariable(varName, 1);
					return true;
				}
				
			}
		}
		
		return false;
	}
	
	private static boolean subsumption(Klauselmenge klm,Anweisungsbaum a){
		/*
		 * Führt Subsumption Regel auf der Klauselmenge durch. Gibt zurück, ob Regel angewendet wurde.
		 */
		
		/*
		 * Idee: Doppelte for Schleife.
		 */
		
		System.out.println("Subsumption-Regel ");
		ListIterator<Klausel> litr = klm.getKlauseln().listIterator();
		
		while (litr.hasNext()) {
			Klausel element = litr.next();
			
			
			//Prüfe zuerst, ob Klausel Tautologie ist.
			HashSet<String> vars = element.getVariablenMitNegation();
			
			Iterator<String> iter = vars.iterator();		
			while (iter.hasNext()) {		//Für alle Variablen...
				String betrachtet = iter.next();
				//System.out.println("betrachte Variable: "+betrachtet);
				if (vars.contains(betrachtet) && vars.contains("!"+betrachtet)){
					//System.out.println("Tautologie gefunden: "+ betrachtet);
					a.setBezeichner(element.toString());
					System.out.println("Subsumption (Tautologie) mit : "+ element);
					
					litr.remove();					
					return true;
					}
				
			
				}
			
						
			//Vergleiche mit anderen Klauseln
			ListIterator<Klausel> litb = klm.getKlauseln().listIterator();		
			
			while (litb.hasNext()) {
				Klausel elementb = litb.next();
				
				//System.out.println("Element a: "+ element.toString()+ "   Element b: " + elementb.toString());
				if (!element.equals(elementb)){
					if(elementb.getVariablenMitNegation().containsAll(element.getVariablen())){
						//System.out.println("SubS gefunden: "+elementb.toString()+" enthält "+element.toString());
						a.setBezeichner(elementb.toString());
						System.out.println("Subsumption mit : "+ elementb);
						
						litb.remove();
						return true;
						
					}
				}
			}
		}
		
		return false;
	}
	
	private static Variable split(Klauselmenge klm){
		/*
		 * Führt Split Regel auf der Klauselmenge durch. Gibt zurück, welche Variable gesplittet wird.
		 */
		
		/*
		 * Idee: Erste Variable im HashSet.
		 */
		if (!klm.getVariablenOhneNegation().isEmpty()){
			return klm.getKlauseln().get(0).getVariablen().get(0);		
			
		}
		
		System.out.println("Split auf leere Menge angewandt! " + klm.toString());
		return null;
	}
	
}